# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section   free

Name:           netcdf-java
Version:        4.0
Release:	1%{?dist}
Epoch:          0
Summary:        NetCDF Java Library
Group:          Development/Libraries/Java
License:        MIT-style
URL:            http://www.unidata.ucar.edu/software/netcdf-java/
Source0:        ftp://ftp.unidata.ucar.edu/pub/netcdf-java/v4.0/ncSrc-4.0.zip

#Patch0:         netcdf-java-build.patch
Patch0:         netcdf-java-cdm-build.patch
Patch1:         netcdf-java-CoordSysBuilder-restore-addCoordinateSystems.patch
Patch2:         netcdf-java-GempakLookup.patch
Patch3:         netcdf-java-McIDASLookup.patch

BuildRequires:  jpackage-utils >= 0:5.0.0
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant
BuildRequires:  berkeleydb-je3
#BuildRequires:  bounce
#BuildRequires:  bufr
#BuildRequires:  bufrTables
#BuildRequires:  casclient
BuildRequires:  apache-commons-codec
BuildRequires:  apache-commons-fileupload
BuildRequires:  apache-commons-httpclient
BuildRequires:  apache-commons-io
BuildRequires:  apache-commons-lang
BuildRequires:  apache-commons-logging
BuildRequires:  ehcache
BuildRequires:  jgoodies-forms
BuildRequires:  gnu-getopt
BuildRequires:  gnu-regexp
BuildRequires:  grib-decoder-java
BuildRequires:  httpunit
BuildRequires:  jcommon
BuildRequires:  jdom
BuildRequires:  jfreechart
#BuildRequires:  jj2000
BuildRequires:  jna
BuildRequires:  joda-time
#BuildRequires:  jpeg
BuildRequires:  glassfish-jstl
BuildRequires:  junit4
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  lucene1
BuildRequires:  lucene
BuildRequires:  nlog4j
BuildRequires:  opendap
#BuildRequires:  prefsAll
#BuildRequires:  protobuf
#BuildRequires:  resourcesOptional ?
BuildRequires:  servlet_2_4_api
BuildRequires:  slf4j
BuildRequires:  spring2-all
BuildRequires:  spring2-test
BuildRequires:  spring2-webmvc
BuildRequires:  jakarta-taglibs-standard
BuildRequires:  stax_1_0_api
BuildRequires:  tomcat5
#BuildRequires:  visadNoDods ?
BuildRequires:  wstx
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
Requires:  java >= 0:1.6.0
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The NetCDF-Java library implements a Common Data Model (CDM),
a generalization of the NetCDF, OpenDAP and HDF5 data models.
The library is a prototype for the NetCDF-4 project, which
provides a C language API for the "data access layer" of the
CDM, on top of the HDF5 file format. The NetCDF-Java library
is a 100% Java framework for reading  netCDF and other file
formats into the CDM, as well as writing  to the netCDF-3
file format. The NetCDF-Java library also implements NcML,
which allows you to add metadata to CDM datasets, as well as
to create virtual datasets through aggregation.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%prep 
%setup -q -c
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
mv lib/external/bounce-0.14.jar.no lib/external/bounce-0.14.jar
mv lib/external/casclient-2.1.1.jar.no lib/external/casclient-2.1.1.jar
ln -sf $(build-classpath tomcat5/catalina) lib/external/catalina.jar
ln -sf $(build-classpath commons-codec) lib/external/commons-codec-1.3.jar
ln -sf $(build-classpath commons-fileupload) lib/external/commons-fileupload-1.2.1.jar
ln -sf $(build-classpath commons-httpclient) lib/external/commons-httpclient-3.1.jar
ln -sf $(build-classpath commons-io) lib/external/commons-io-1.4.jar
ln -sf $(build-classpath commons-lang) lib/external/commons-lang-2.4.jar
ln -sf $(build-classpath commons-logging) lib/external/commons-logging-1.1.jar
ln -sf $(build-classpath ehcache) lib/external/ehcache-1.6.0-beta3.jar
ln -sf $(build-classpath jgoodies-forms) lib/external/forms-1.0.7.jar
ln -sf $(build-classpath gnu-getopt) lib/external/gnu-getopt-1.0.6.jar
ln -sf $(build-classpath gnu-regexp) lib/external/gnu-regexp-1.1.4.jar
ln -sf $(build-classpath httpunit) lib/external/httpunit.jar
ln -sf $(build-classpath jcommon) lib/external/jcommon-1.0.15.jar
ln -sf $(build-classpath jdom) lib/external/jdom.jar
ln -sf $(build-classpath berkeleydb-je3) lib/external/je-3.3.62.jar
ln -sf $(build-classpath jfreechart) lib/external/jfreechart-1.0.12.jar
ln -sf $(build-classpath jna) lib/external/jna.jar
ln -sf $(build-classpath joda-time) lib/external/joda-time-1.6.jar
mv lib/external/jpeg-1.0.jar.no lib/external/jpeg-1.0.jar
ln -sf $(build-classpath jj2000) lib/external/jpeg2000.jar
ln -sf $(build-classpath jstl) lib/external/jstl.jar
ln -sf $(build-classpath junit4) lib/external/junit-4.5.jar
ln -sf $(build-classpath junit) lib/external/junit.jar
ln -sf $(build-classpath log4j) lib/external/log4j-1.2.15.jar
ln -sf $(build-classpath lucene) lib/external/lucene-core-2.3.2.jar
ln -sf $(build-classpath lucene1) lib/external/lucene.jar
mv lib/external/protobuf-java-2.1.0.jar.no lib/external/protobuf-java-2.1.0.jar
ln -sf $(build-classpath servlet_2_4_api) lib/external/servlet-api.jar
ln -sf $(build-classpath slf4j/api) lib/external/slf4j-api-1.5.6.jar
ln -sf $(build-classpath slf4j/jdk14) lib/external/slf4j-jdk14-1.5.6.jar
ln -sf $(build-classpath slf4j/log4j12) lib/external/slf4j-log4j12-1.5.6.jar
#lib/external/source/junit-4.5-src.jar.no
#lib/external/source/spring-sources-2.5.jar.no
#lib/external/source/spring-test-sources-2.5.jar.no
#lib/external/source/spring-webmvc-sources-2.5.jar.no
ln -sf $(build-classpath servlet_2_4_api) lib/external/servlet-api.jar
ln -sf $(build-classpath spring2) lib/external/spring-2.5.jar
ln -sf $(build-classpath spring2/test) lib/external/spring-test-2.5.jar
ln -sf $(build-classpath spring2/webmvc) lib/external/spring-webmvc-2.5.jar
ln -sf $(build-classpath taglibs-standard) lib/external/standard.jar
ln -sf $(build-classpath stax_1_0_api) lib/external/stax-api-1.0.1.jar
ln -sf $(build-classpath wstx/wstx-lgpl) lib/external/wstx-lgpl-3.2.5.jar
mv lib/release/bufr-1.4.jar.no lib/release/bufr-1.4.jar
mv lib/release/bufr-1.5.jar.no lib/release/bufr-1.5.jar
mv lib/release/bufrTables-1.5.jar.no lib/release/bufrTables-1.5.jar
ln -sf $(build-classpath grib-decoder-java) lib/release/grib-6.0.jar
#lib/release/ncIdv.jar.no
#lib/release/netcdf-4.0.jar.no
mv lib/release/opendap-2.1.jar.no lib/release/opendap-2.1.jar
mv lib/release/prefsAll.jar.no lib/release/prefsAll.jar
mv lib/release/resourcesOptional.jar.no lib/release/resourcesOptional.jar
mv lib/release/visadNoDods.jar.no lib/release/visadNoDods.jar

%build
cd cdm
ant -Dbuild.sysclasspath=first dist
#	makeCore \
#	makeIDVjar \
#	makeMain \
#	makeMainComplete \
#	makeResourcesOptional \
#	javadoc

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}/%{name}

install -m 644 cdm/target/ncIdv.jar \
           %{buildroot}%{_javadir}/%{name}/ncIdv-%{version}.jar
install -m 644 cdm/target/toolsUI-%{version}.jar \
           %{buildroot}%{_javadir}/%{name}/toolsUI-%{version}.jar
install -m 644 cdm/target/netcdfAll-%{version}.jar \
           %{buildroot}%{_javadir}/%{name}/netcdfAll-%{version}.jar
install -m 644 cdm/target/netcdfUI-%{version}.jar \
           %{buildroot}%{_javadir}/%{name}/netcdfUI-%{version}.jar
install -m 644 cdm/target/netcdf-%{version}.jar \
           %{buildroot}%{_javadir}/%{name}/netcdf-%{version}.jar
install -m 644 cdm/target/ncCore-%{version}.jar \
           %{buildroot}%{_javadir}/%{name}/ncCore-%{version}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do \
ln -s ${jar} ${jar/-%{version}/}; done)

# javadoc
install -dm 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr cdm/target/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Thu Jul 08 2010 Ralph Apel <r.apel@r-apel.de> 4.0-1
- 4.0

* Sat Jul 03 2010 Ralph Apel <r.apel@r-apel.de> 0.7-1
- first release

